Attribute VB_Name = "mdlMP3"
' by TEKER 2002

Option Explicit

Public Type TagInfo
  TAG As String * 3
  Songname As String * 30
  artist As String * 30
  album As String * 30
  year As String * 4
  comment As String * 30
  genre As String * 1
End Type

Public Path$, WINAMPPATH$

Public Function GET_ID3V1TAG(FilePath$, TAG As TagInfo) As Boolean
    Dim FNum%, fso As New FileSystemObject
    On Error GoTo ERRORS
    
    If Not fso.FileExists(FilePath) Then
        GET_ID3V1TAG = False
        Exit Function
    End If
    With TAG
        FNum = FreeFile
        Open FilePath For Binary As #FNum
        Get #FNum, LOF(FNum) - 127, .TAG
        If .TAG <> "TAG" Then
            GET_ID3V1TAG = False
            Close #FNum
            Exit Function
        End If
        Get #FNum, , .Songname
        Get #FNum, , .artist
        Get #FNum, , .album
        Get #FNum, , .year
        Get #FNum, , .comment
        Get #FNum, , .genre
        Close #FNum
        GET_ID3V1TAG = True
    End With

    Exit Function
ERRORS:
    GET_ID3V1TAG = False
    Close #FNum
End Function

Public Function PUT_ID3V1TAG(FilePath$, TAG As TagInfo) As Boolean
    Dim FNum%, TPos&
    On Error GoTo ERRORS
    
    With TAG
        FNum = FreeFile
        Open FilePath For Binary As #FNum
        TPos = LOF(FNum)
        Get #FNum, TPos - 127, .TAG
        If .TAG = "TAG" Then TPos = TPos - 127
        .TAG = "TAG"
        Put #FNum, TPos, TAG
        Close #FNum
        PUT_ID3V1TAG = True
    End With

    Exit Function
ERRORS:
    PUT_ID3V1TAG = False
End Function

